/***************************************************
    Station rev 1.2 31.05.2017 by Sergi
		stm32f030k6 ILI9325 SPI
***************************************************/

#include <stm32f0xx.h>
#include "ILI9325lib.h"
#include "i2c_soft.h"
#include <string.h>

volatile int temp,dsec = 0,dtim = 0,ttherm[4][11],therm[4],sleep_cnt,sleep_solder_cnt;
volatile unsigned char tim_fl = 0,dsec_fl = 0,tptr = 0;
char txt[7];
unsigned char test = 0,key,key_cnt,home,con[4],en[4],ptr=3,sleep,sleep_solder,sleep_fl,sleep_solder_fl,mute = 1;
unsigned int set_th[4] = {30,0,0,200},t[4],sleep_time = 300,sleep_solder_time = 300,
						 ts_a = 35,ts_h = 52,ts_t = 52,ts_s = 52;
signed int Kp[4]={0,10,40,40},	// size 1/10
					 Ki[4]={0,2,3,4},			// size 1/80
					 Kd[4]={0,10,60,80},	// size 1/80
					 s_err[4],s_err_max[4] = {9,9,1000,1500},p_err[4],load[4];
					 
void init_gpio(void)
	{
	RCC->AHBENR|=RCC_AHBENR_GPIOAEN;    
	RCC->AHBENR|=RCC_AHBENR_GPIOBEN;
	
	GPIOA->MODER &=~ GPIO_MODER_MODER0;	//key
	GPIOA->MODER &=~ GPIO_MODER_MODER1;
	GPIOA->MODER &=~ GPIO_MODER_MODER2;
		
	GPIOA->MODER |=  GPIO_MODER_MODER3;	//adc
	GPIOA->MODER |=  GPIO_MODER_MODER4;
	GPIOA->MODER |=  GPIO_MODER_MODER5;
	GPIOA->MODER |=  GPIO_MODER_MODER6;
	
	GPIOA->MODER &=~ GPIO_MODER_MODER7;	//key home
		
	GPIOA->MODER &=~  GPIO_MODER_MODER8;	//TIM1_CH1	
	GPIOA->MODER |= GPIO_MODER_MODER8_1;		 
	GPIOA->OTYPER &=~ GPIO_OTYPER_OT_8;			
	GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR8;   			
	GPIOA->AFR[1] |= (0x02);	
		
	GPIOA->MODER &=~  GPIO_MODER_MODER9;	//TIM1_CH2	
	GPIOA->MODER |= GPIO_MODER_MODER9_1;		 
	GPIOA->OTYPER &=~ GPIO_OTYPER_OT_9;			
	GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR9;   			
	GPIOA->AFR[1] |= (0x02 << 4);
	
	GPIOA->MODER &=~  GPIO_MODER_MODER10;	//TIM1_CH3	
	GPIOA->MODER |= GPIO_MODER_MODER10_1;		 
	GPIOA->OTYPER &=~ GPIO_OTYPER_OT_10;			
	GPIOA->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR10;   			
	GPIOA->AFR[1] |= (0x02 << 8);

	GPIOA->MODER &=~ GPIO_MODER_MODER12;
	
	GPIOB->MODER &=~  GPIO_MODER_MODER0;	//TIM3_CH3			 
	GPIOB->OTYPER &=~ GPIO_OTYPER_OT_0;			
	GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR0;   			
	GPIOB->AFR[0] |= (0x01);

	GPIOB->MODER &=~  GPIO_MODER_MODER1;	//TIM14_CH1	
	GPIOB->MODER |= GPIO_MODER_MODER1_1;		 
	GPIOB->OTYPER &=~ GPIO_OTYPER_OT_1;			
	GPIOB->OSPEEDR |= GPIO_OSPEEDER_OSPEEDR1;   			
	
	GPIOB->MODER &=~  GPIO_MODER_MODER6;		//I2C_SCL
	GPIOB->OTYPER |= GPIO_OTYPER_OT_6;							     
	GPIOB->MODER |= GPIO_MODER_MODER6_0;		
	GPIOB->BSRR = GPIO_BSRR_BS_6;
	
	GPIOB->MODER &=~  GPIO_MODER_MODER7;		//I2C_SDA
	GPIOB->OTYPER |= GPIO_OTYPER_OT_7;							     
	GPIOB->MODER |= GPIO_MODER_MODER7_0;		
	GPIOB->BSRR = GPIO_BSRR_BS_7;		
	};
void init_adc(void)
	{
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN; 
	RCC->CR2 |= RCC_CR2_HSI14ON; 
	while ((RCC->CR2 & RCC_CR2_HSI14RDY) == 0)   {  };
	if ((ADC1->CR & ADC_CR_ADEN) != 0) 
		{
		ADC1->CR &= (uint32_t)(~ADC_CR_ADEN);  
		}
	ADC1->CR |= ADC_CR_ADCAL; 
	while ((ADC1->CR & ADC_CR_ADCAL) != 0)   {  };  
	__NOP();__NOP();   
	ADC1->CFGR1 |= ADC_CFGR1_AUTOFF;
	ADC1->CHSELR = ADC_CHSELR_CHSEL17; 
	ADC1->SMPR |= ADC_SMPR1_SMPR_0 | ADC_SMPR1_SMPR_1 | ADC_SMPR1_SMPR_2;  
	ADC1->CR |= ADC_CR_ADEN; 
	};

int read_adc(uint16_t chann)
	{	
	ADC1->CR &=~ ADC_CR_ADSTART;
  ADC1->CR |= ADC_CR_ADSTP;      
  ADC1->CHSELR = (1<<chann);
	ADC1->CR &=~ ADC_CR_ADSTP;
	ADC1->CR |= ADC_CR_ADSTART; 
  while (!(ADC1->ISR & ADC_ISR_EOC)){};
	return ADC1->DR;
	};
	
void SysTick_Handler(void)
	{
    dsec_fl = 1;
		if(++tptr > 10) tptr = 1;
		temp = read_adc(3);ttherm[0][0] = ttherm[0][0] - ttherm[0][tptr] + temp;ttherm[0][tptr] = temp;therm[0] = ttherm[0][0]/10;
		temp = read_adc(5);ttherm[1][0] = ttherm[1][0] - ttherm[1][tptr] + temp;ttherm[1][tptr] = temp;therm[1] = ttherm[1][0]/10;
		temp = read_adc(4);ttherm[2][0] = ttherm[2][0] - ttherm[2][tptr] + temp;ttherm[2][tptr] = temp;therm[2] = ttherm[2][0]/10;
		temp = read_adc(6);ttherm[3][0] = ttherm[3][0] - ttherm[3][tptr] + temp;ttherm[3][tptr] = temp;therm[3] = ttherm[3][0]/10;
		if(++dsec >= 10) 
		{
			dsec = 0;
			if (sleep) 
			{
				sleep_cnt++;
				if (sleep_cnt > sleep_time) sleep_fl = 1,sleep_cnt = sleep_time + 1;
			} else sleep_cnt = 0;
			
			if (sleep_solder) 
			{
				sleep_solder_cnt++;
				if (sleep_solder_cnt > sleep_solder_time) sleep_solder_fl = 1,sleep_solder_cnt = sleep_solder_time + 1;
			} else sleep_solder_cnt = 0;
			
		};		
	};

void init_tim1(void)
	{
	RCC->APB2ENR |= RCC_APB2ENR_TIM1EN;           
	TIM1->CR1 |= TIM_CR1_ARPE;
	TIM1->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1 | TIM_CCMR1_OC2M_2 | TIM_CCMR1_OC2M_1;
	TIM1->CCMR1 |= TIM_CCMR1_OC1FE | TIM_CCMR1_OC2FE;
	TIM1->CCMR2 |= TIM_CCMR2_OC3M_2 | TIM_CCMR2_OC3M_1;
	TIM1->CCMR2 |= TIM_CCMR2_OC3FE;
	TIM1->CCER |= TIM_CCER_CC1E | TIM_CCER_CC2E | TIM_CCER_CC3E;
	TIM1->DIER |= TIM_DIER_UIE;
	TIM1->PSC = 48000-1;			
	TIM1->ARR = 1000-1;			// 1Hz
	TIM1->CCR1 = 0;
	TIM1->CCR2 = 0;
	TIM1->CCR3 = 0;		
	TIM1->BDTR |= TIM_BDTR_MOE;
	TIM1->CR1 |= TIM_CR1_CEN;
	};

void init_tim14(void)
	{
	RCC->APB1ENR |= RCC_APB1ENR_TIM14EN;      
	TIM14->CR1 |= TIM_CR1_ARPE;
	TIM14->CR2 |= TIM_CR2_OIS1;
	TIM14->CCMR1 |= TIM_CCMR1_OC1M_2 | TIM_CCMR1_OC1M_1;
	TIM14->CCMR1 |= TIM_CCMR1_OC1FE;
	TIM14->CCER |= TIM_CCER_CC1E;
	TIM14->PSC = 48-1;			
	TIM14->ARR = 100-1;		//tim14 generate 10 kHz 
	TIM14->CCR1 = 1;	//duty		
	TIM14->BDTR |= TIM_BDTR_MOE;
	TIM14->CR1 |= TIM_CR1_CEN;
	};
void fan(int speed)
{
	if (speed > 100) speed = 100;
	TIM14->CCR1 = speed;
};
void init_tim3(void)
	{
	RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;           
	TIM3->CR1 |= TIM_CR1_ARPE;
	TIM3->CCMR2 |= TIM_CCMR2_OC3M_2 | TIM_CCMR2_OC3M_1;
	TIM3->CCMR2 |= TIM_CCMR2_OC3FE;
	TIM3->CCER |= TIM_CCER_CC3E;
	TIM3->PSC = 48-1;			
	TIM3->ARR = 2000-1;	// 500 Hz
	TIM3->CCR3 = 1000;
	TIM3->BDTR |= TIM_BDTR_MOE;
	};

void beep (int time)
{
	if (!mute)
	{
	GPIOB->MODER |= GPIO_MODER_MODER0_1;
	TIM3->CR1 |= TIM_CR1_CEN;
	};
	delay_us(time*1000);
	TIM3->CR1 &=~ TIM_CR1_CEN;
	GPIOB->MODER &=~ GPIO_MODER_MODER0;
	
};
void TIM1_BRK_UP_TRG_COM_IRQHandler (void)
{
	TIM1->SR &=~ TIM_SR_UIF;
	tim_fl = 1;
};

void save_settings (void)
{
	i2c_write_data(10,set_th[0]);
	i2c_write_data(11,set_th[1] >> 8);
	i2c_write_data(12,set_th[1] & 0xff);
	i2c_write_data(13,set_th[2] >> 8);
	i2c_write_data(14,set_th[2] & 0xff);
	i2c_write_data(15,set_th[3] >>8 );
	i2c_write_data(16,set_th[3] & 0xff);
};
void save_tune (void)
{
	i2c_write_data(17,Kp[1]);
	i2c_write_data(18,Kp[2]);
	i2c_write_data(19,Kp[3]);
	i2c_write_data(20,Ki[1]);
	i2c_write_data(21,Ki[2]);
	i2c_write_data(22,Ki[3]);
	i2c_write_data(23,Kd[1]);
	i2c_write_data(24,Kd[2]);
	i2c_write_data(25,Kd[3]);
	i2c_write_data(26,ts_a);
	i2c_write_data(27,ts_h);
	i2c_write_data(28,ts_t);
	i2c_write_data(29,ts_s);
};

void load_settings(void)
{
	set_th[0] = i2c_read_data(10);
	set_th[1] = 0;
	set_th[1] |= (int)(i2c_read_data(11))<<8 | i2c_read_data(12);
	set_th[2] = 0;
	set_th[2] |= (int)(i2c_read_data(13))<<8 | i2c_read_data(14);
	set_th[3] = 0;
	set_th[3] |= (int)(i2c_read_data(15))<<8 | i2c_read_data(16);
};

void load_tune(void)
{
	//  to comment for 1st compiling
	Kp[1] = i2c_read_data(17);
	Kp[2] = i2c_read_data(18);
	Kp[3] = i2c_read_data(19);
	Ki[1] = i2c_read_data(20);
	Ki[2] = i2c_read_data(21);
	Ki[3] = i2c_read_data(22);
	Kd[1] = i2c_read_data(23);
	Kd[2] = i2c_read_data(24);
	Kd[3] = i2c_read_data(25);

	ts_a = i2c_read_data(26);
	ts_h = i2c_read_data(27);
	ts_t = i2c_read_data(28);
	ts_s = i2c_read_data(29);
//
};
void driver (unsigned char channel)
{
	signed int err;
	if (con[channel] && en[channel])
			{
				if (sleep_solder_fl && (channel == 3)) err = set_th[channel] - 100 - t[channel];
				else err = set_th[channel] - t[channel];
				load[channel] = Kp[channel]*err + ((Ki[channel]*s_err[channel])>>3) + ((Kd[channel]*(err-p_err[channel]))>>3) ;
				p_err[channel] = err;s_err[channel] +=err;
				if (s_err[channel] > s_err_max[channel]) s_err[channel] = s_err_max[channel];
				else if (s_err[channel] < -s_err_max[channel]) s_err[channel] = -s_err_max[channel];
				if (load[channel] > 999) load[channel] = 999;
				else if (load[channel] < 0) load[channel] = 0;
			}
				else load[channel] = 0,s_err[channel] = 0;
			if (channel == 1) TIM1->CCR2 = load[channel];
				else if (channel == 2) TIM1->CCR1 = load[channel];
							else  TIM1->CCR3 = load[channel];
};

void EXTI4_15_IRQHandler (void)
{
	EXTI->PR |= 0x1000;
	if ((test == 0) || (test == 2) || (test == 4)) save_settings();else save_tune();
	put_string (50,12,"SAVE",White,Black),delay_us(5000000);
};

int main (void)
{	
		RCC->CFGR |= RCC_CFGR_PLLSRC_HSI_DIV2;
		RCC->CFGR |= (12-2)<<18; 					/// HSI/2*12=48
		RCC->CR |= RCC_CR_PLLON;
		while (!(RCC->CR & RCC_CR_PLLRDY)) {}; 
		RCC->CFGR |= RCC_CFGR_SW_PLL;
		RCC->CFGR |= RCC_CFGR_HPRE_DIV1;    
		RCC->CFGR |= RCC_CFGR_PPRE_DIV1;
		init_gpio();
		delay_us(200000);			
		init_lcd();fill_lcd(Black);
		init_adc();
		init_tim1();init_tim3();init_tim14();
		RCC->APB2ENR |= RCC_APB2ENR_SYSCFGEN;
		SysTick_Config(4800000); // .1sec
		NVIC_EnableIRQ(TIM1_BRK_UP_TRG_COM_IRQn);
		EXTI->FTSR |= 0x1000;
		EXTI->IMR |= 0x1000;
		NVIC_EnableIRQ(EXTI4_15_IRQn);	//Pow off save
		TIM1->CCR1 = 0;TIM1->CCR2 = 0;TIM1->CCR3 = 0;
		beep(1);
		load_settings();load_tune();
		if (set_th[0] < 20) set_th[0] = 20,fan(set_th[0]);
		put_string (25,200,"SOLDER SET",Orange,Black);
		put_string (25,136," TABLE SET",Magenta,Black);
		put_string (25,72,"  HOT SET",Yellow,Black);
		put_string (25,40,"  FAN SET",Cyan,Black);
		put_string (178,40,"%",Cyan,Black);
		dig_string (295,47,":",Green,Black,1);		// ":" == "CELSIUM"
		dig_string (271,111,":",Yellow,Black,2);
		dig_string (271,175,":",Magenta,Black,2);
		dig_string (271,239,":",Orange,Black,2);
		dig_string (88,111,":",White,Black,1);
		dig_string (88,175,":",White,Black,1);
		dig_string (88,239,":",White,Black,1);
	
		con[1] = 0,en[1] = 0;con[2] = 0,en[2] = 0;con[3] = 0,en[3] = 0;

		test =(~GPIOA->IDR)&0x07;
		mute = 0;
		switch (test)
					{		
						case 0:	 put_string (10,12,"        ",White,Black);break;						
						case 2:  put_string (10,12,"  MUTE  ",White,Black);mute = 1;break;
						case 1:  put_string (10,12,"TUNE SLD",White,Black);set_th[2] = Kp[3]; set_th[1] = Ki[3];set_th[0] = Kd[3];break;
						case 5:  put_string (10,12,"TUNE HOT",White,Black);set_th[3] = Kp[1]; set_th[2] = Ki[1];set_th[0] = Kd[1];break;
						case 6:  put_string (10,12,"TUNE TBL",White,Black);set_th[3] = Kp[2]; set_th[1] = Ki[2];set_th[0] = Kd[2];break;
						case 4:  put_string (10,12,"POW INFO",White,Black);break;
						case 3:	 put_string (10,12,"TUNE TMP",White,Black);set_th[0] = ts_a; set_th[1] = ts_h;set_th[2] = ts_t;set_th[3] = ts_s;break;			
					};
		

			while(1)
		{
			if (dsec_fl) 
			{
			dsec_fl = 0;
				temp = GPIOA->IDR;
				key = (~GPIOA->IDR)&0x07;home = ((~GPIOA->IDR) & 0x80) >> 7;
				if (home) sleep_solder = 1; else sleep_solder = 0,sleep_solder_fl = 0;
				if (key)
				{
					beep(3);
					key_cnt++;
					switch (key)
					{				
						case 1: if (en[ptr]) en[ptr] = 0; else en[ptr] = 1;beep(200);sleep_cnt = 0;sleep_fl = 0;
										if (ptr == 0) 
										{
											if (en[1]) en[1] = 0; else en[1] = 1;
										};
										break;	//ON
						case 4: if (key_cnt > 10) {
										if (ptr) {if (set_th[ptr] > 9) set_th[ptr] = set_th[ptr] - 10;} 
										else {if ((test == 0) || (test == 2)) {if (set_th[ptr] > 29) set_th[ptr]= set_th[ptr] - 10;} else {
										if (set_th[ptr] > 9) set_th[ptr]= set_th[ptr] - 10;};}; 
											} else {	
										if (ptr) {if (set_th[ptr] > 0) set_th[ptr]--;} 
										else {if ((test == 0) || (test == 2)) {if (set_th[ptr] > 20) set_th[ptr]--;} else {
										if (set_th[ptr] > 0) set_th[ptr]--;};}; 
										};
										break;	//Left
						case 3: if (sleep) sleep = 0; else sleep = 1,beep(200);
										if ((test == 0) || (test == 2)) save_settings();else save_tune(); 
										break;	//Centr
						case 2: if (key_cnt > 10) {
										if (ptr) {if (set_th[ptr] < 491) set_th[ptr] = set_th[ptr] + 10;} 
										else {if (set_th[ptr] < 91) set_th[ptr]= set_th[ptr] + 10;};
										} else {
										if (ptr) {if (set_th[ptr] < 500) set_th[ptr]++;} 
										else {if (set_th[ptr] < 99) set_th[ptr]++;};
										};
										break;	//Right
						case 5: if (ptr > 0) ptr--; break;	//Up
						case 6: if (ptr < 3) ptr++; break;	//Down					
					};
			
				} else key_cnt = 0;
				if (sleep) 
				{	
				if (sleep_fl) put_string (140,12,"SLEEP",Red,Black); 
					else put_string (140,12,"SLEEP",Green,Black);		
				}
				else put_string (140,12,"     ",White,Black); 			
				if ((test == 0) || (test == 2) || (test == 4)) 
				{
					itoa(set_th[0]-15,txt); 
					if ((set_th[0]-15) < 10) dig_string (127,47," ",Black,Black,1);	//fan
				}
				else 
				{
					itoa(set_th[0],txt);
					if (set_th[0] < 10) dig_string (127,47," ",Black,Black,1);	
				};
				if (ptr == 0) dig_string (175-strlen(txt)*24,47,txt,Black,Cyan,1);
							else dig_string (175-strlen(txt)*24,47,txt,Cyan,Black,1);
				if (!sleep_fl && en[1]) fan(set_th[0]); else 
				if (t[1] > (t[0]+40)) fan(20); else fan(0);
				if (set_th[1] < 100) dig_string (16,111," ",Black,Black,1);	//hot
				if (set_th[1] < 10) dig_string (40,111," ",Black,Black,1);
				itoa(set_th[1],txt);
				if (ptr == 1) dig_string (88-strlen(txt)*24,111,txt,Black,White,1);
							else dig_string (88-strlen(txt)*24,111,txt,White,Black,1);
				if (set_th[2] < 100) dig_string (16,175," ",Black,Black,1);	//table
				if (set_th[2] < 10) dig_string (40,175," ",Black,Black,1);
				itoa(set_th[2],txt);
				if (ptr == 2)  dig_string (88-strlen(txt)*24,175,txt,Black,White,1);
							else dig_string (88-strlen(txt)*24,175,txt,White,Black,1);
				if (set_th[3] < 100) dig_string (16,239," ",Black,Black,1);	//solder
				if (set_th[3] < 10) dig_string (40,239," ",Black,Black,1);
				itoa(set_th[3],txt);
				if (ptr == 3) dig_string (88-strlen(txt)*24,239,txt,Black,White,1);
							else dig_string (88-strlen(txt)*24,239,txt,White,Black,1);
				switch (test)
				{
				case 5:
				{					
				Kp[1] = set_th[3]; Ki[1] = set_th[2];Kd[1] = set_th[0];		
				itoa(s_err[1],txt);put_string (10,24,"S ERR      ",Yellow,Black);put_string (58,24,txt,Yellow,Black);			
				}; break;
				case 6:
				{					
				Kp[2] = set_th[3]; Ki[2] = set_th[1];Kd[2] = set_th[0];		
				itoa(s_err[2],txt);put_string (10,24,"S ERR      ",Magenta,Black);put_string (58,24,txt,Magenta,Black);			
				};break;
				case 1:
				{					
				Kp[3] = set_th[2]; Ki[3] = set_th[1];Kd[3] = set_th[0];		
				itoa(s_err[3],txt);put_string (10,24,"S ERR      ",Orange,Black);put_string (58,24,txt,Orange,Black);			
				};break;
				case 3:
				{					
				ts_a = set_th[0]; ts_h = set_th[1];ts_t = set_th[2];ts_s = set_th[3];				
				};break;
				/*
				case 2: 
					for (i=0;i<4;i++)
					{
					itoa(therm[i],txt);put_string (10,48+12*i,"      ",White,Black);put_string (10,48+12*i,txt,Green,Black);
					}; break;
				*/
			};
			};
			
			
			if (tim_fl) 
			{
			tim_fl = 0; 
			if (therm[0] >= 1420) t[0] = ((therm[0]-1420)*ts_a)>>10;	else t[0] = 0;	
			if (therm[1] >= 724)  t[1] = t[0]+(((therm[1]-724)*ts_h)>>8);	else t[1] = t[0];
			if (therm[2] >= 730)  t[2] = t[0]+(((therm[2]-730)*ts_t)>>8);	else t[2] = t[0];
			if (therm[3] >= 12) 	 t[3] = t[0]+(((therm[3]-12)*ts_s)>>8);	else t[3] = t[0];
			
			if (t[1] > 600) con[1] = 0,en[1] = 0;
				else con[1] = 1;
			if (t[2] > 600) con[2] = 0,en[2] = 0;
				else con[2] = 1;
			if (t[3] > 600) con[3] = 0,en[3] = 0;
				else con[3] = 1;
			if (sleep_fl) en[1] = 0, en[2] = 0;
			if (t[0] < 10) dig_string (247,47," ",Black,Black,1);
			itoa(t[0],txt);dig_string (295-strlen(txt)*24,47,txt,Green,Black,1);
				
			itoa(t[1],txt);
			if (en[1])
			{	
			if (t[1] < 100) dig_string (127,111," ",Black,((load[1]>>5)<<11),2);
			if (t[1] < 10) dig_string (175,111," ",Black,((load[1]>>5)<<11),2);
			itoa(t[1],txt);dig_string (271-strlen(txt)*48,111,txt,Yellow,((load[1]>>5)<<11),2);
			} else { dig_string (127,111,"   ",Yellow,Black,2);
							 if (!con[1]) put_string (127,95,"NOT CONNECTED",Red,Black);
									else put_string (127,95,"TURNED OFF     :",Green,Black),put_string (215,95,txt,Green,Black);
						 };
			itoa(t[2],txt);
			if (en[2])
			{		
			if (t[2] < 100) dig_string (127,175," ",Black,((load[2]>>5)<<11),2);
			if (t[2] < 10) dig_string (175,175," ",Black,((load[2]>>5)<<11),2);
			itoa(t[2],txt);dig_string (271-strlen(txt)*48,175,txt,Magenta,((load[2]>>5)<<11),2);
			} else { dig_string (127,175,"   ",Magenta,Black,2);
							 if (!con[2]) put_string (127,159,"NOT CONNECTED",Red,Black);
									else put_string (127,159,"TURNED OFF     :",Green,Black),put_string (215,159,txt,Green,Black);
						 };
			itoa(t[3],txt);
			if (en[3])
			{
			if (t[3] < 100) dig_string (127,239," ",Black,((load[3]>>5)<<11),2);
			if (t[3] < 10) dig_string (175,239," ",Black,((load[3]>>5)<<11),2);
			dig_string (271-strlen(txt)*48,239,txt,Orange,((load[3]>>5)<<11),2);
			} else { dig_string (127,239,"   ",Orange,Black,2);
							 if (!con[3]) put_string (127,223,"NOT CONNECTED",Red,Black);
									else put_string (127,223,"TURNED OFF     :",Green,Black),put_string (215,223,txt,Green,Black);
							};
			//driver
			s_err_max[1] = s_err_max[0]*set_th[0];
			driver(1);driver(2);driver(3);
			if (!((test == 0) || (test == 2)))
			{				
			itoa(load[1]/10,txt);put_string (90,12,"  . %",Yellow,Black);
			if (load[1] > 99) put_string (90,12,txt,Yellow,Black);
					else  put_string (98,12,txt,Yellow,Black); 
			itoa(load[1]%10,txt); put_string (114,12,txt,Yellow,Black);
						
			itoa(load[2]/10,txt);put_string (190,12,"  . %",Magenta,Black);
			if (load[2] > 99) put_string (190,12,txt,Magenta,Black);
					else put_string (198,12,txt,Magenta,Black); 
			itoa(load[2]%10,txt); put_string (214,12,txt,Magenta,Black);
						
			itoa(load[3]/10,txt);put_string (280,12,"  . %",Orange,Black);
			if (load[3] > 99) put_string (280,12,txt,Orange,Black);
					else put_string (288,12,txt,Orange,Black); 
			itoa(load[3]%10,txt); put_string (304,12,txt,Orange,Black);
			};
			};
			
		};
}
